(setq gnus-sort-gathered-threads-function
      #'gnus-thread-sort-by-number)
(setq gnus-thread-sort-functions
      '((not gnus-thread-sort-by-number)))

(defun gnus-sort-threads-recursive (threads func)
  (sort (mapcar (lambda (thread)
		  (cons (car thread)
			(and (cdr thread)
			     (gnus-sort-threads-recursive-1
			      (cdr thread) func))))
		threads) func))

(defun gnus-sort-threads-recursive-1 (threads func)
  (setq func (gnus-make-sort-function
	      '(gnus-thread-sort-by-number)))
  (sort (mapcar (lambda (thread)
		  (cons (car thread)
			(and (cdr thread)
			     (gnus-sort-threads-recursive-1
			      (cdr thread) func))))
		threads) func))
